/* Copyright 2018 The TensorFlow Authors. All Rights Reserved.

Licensed under the Apache License, Version 2.0 (the "License");
you may not use this file except in compliance with the License.
You may obtain a copy of the License at

    http://www.apache.org/licenses/LICENSE-2.0

Unless required by applicable law or agreed to in writing, software
distributed under the License is distributed on an "AS IS" BASIS,
WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
See the License for the specific language governing permissions and
limitations under the License.
=======================================================================*/

package org.tensorflow.op.core;

import javax.annotation.Generated;
import org.tensorflow.Operand;
import org.tensorflow.Operation;
import org.tensorflow.OperationBuilder;
import org.tensorflow.op.PrimitiveOp;
import org.tensorflow.op.Scope;
import org.tensorflow.op.annotation.Operator;

/**
 * Converts the given variant tensor to an iterator and stores it in the given resource.
 */
@Generated(value = "TensorFlow Java Op Generator")
@Operator(group = "core")
public final class DeserializeIterator extends PrimitiveOp {
  
  /**
   * Factory method to create a class to wrap a new DeserializeIterator operation to the graph.
   * 
   * @param scope current graph scope
   * @param resourceHandle A handle to an iterator resource.
   * @param serialized A variant tensor storing the state of the iterator contained in the
   * resource.
   * @return a new instance of DeserializeIterator
   */
  public static DeserializeIterator create(Scope scope, Operand<?> resourceHandle, Operand<?> serialized) {
    OperationBuilder opBuilder = scope.graph().opBuilder("DeserializeIterator", scope.makeOpName("DeserializeIterator"));
    opBuilder.addInput(resourceHandle.asOutput());
    opBuilder.addInput(serialized.asOutput());
    return new DeserializeIterator(opBuilder.build());
  }
  
  
  private DeserializeIterator(Operation operation) {
    super(operation);
  }
}
