/* Copyright 2018 The TensorFlow Authors. All Rights Reserved.

Licensed under the Apache License, Version 2.0 (the "License");
you may not use this file except in compliance with the License.
You may obtain a copy of the License at

    http://www.apache.org/licenses/LICENSE-2.0

Unless required by applicable law or agreed to in writing, software
distributed under the License is distributed on an "AS IS" BASIS,
WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
See the License for the specific language governing permissions and
limitations under the License.
=======================================================================*/

package org.tensorflow.op.core;

import javax.annotation.Generated;
import org.tensorflow.Operand;
import org.tensorflow.Operation;
import org.tensorflow.OperationBuilder;
import org.tensorflow.op.Operands;
import org.tensorflow.op.PrimitiveOp;
import org.tensorflow.op.Scope;
import org.tensorflow.op.annotation.Operator;

/**
 */
@Generated(value = "TensorFlow Java Op Generator")
@Operator(group = "core")
public final class EnqueueInQueueDataset extends PrimitiveOp {
  
  /**
   * Factory method to create a class to wrap a new EnqueueInQueueDataset operation to the graph.
   * 
   * @param scope current graph scope
   * @param queue 
   * @param components 
   * @return a new instance of EnqueueInQueueDataset
   */
  public static EnqueueInQueueDataset create(Scope scope, Operand<?> queue, Iterable<Operand<?>> components) {
    OperationBuilder opBuilder = scope.graph().opBuilder("EnqueueInQueueDataset", scope.makeOpName("EnqueueInQueueDataset"));
    opBuilder.addInput(queue.asOutput());
    opBuilder.addInputList(Operands.asOutputs(components));
    return new EnqueueInQueueDataset(opBuilder.build());
  }
  
  
  private EnqueueInQueueDataset(Operation operation) {
    super(operation);
  }
}
