/* Copyright 2018 The TensorFlow Authors. All Rights Reserved.

Licensed under the Apache License, Version 2.0 (the "License");
you may not use this file except in compliance with the License.
You may obtain a copy of the License at

    http://www.apache.org/licenses/LICENSE-2.0

Unless required by applicable law or agreed to in writing, software
distributed under the License is distributed on an "AS IS" BASIS,
WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
See the License for the specific language governing permissions and
limitations under the License.
=======================================================================*/

package org.tensorflow.op.core;

import javax.annotation.Generated;
import org.tensorflow.Operand;
import org.tensorflow.Operation;
import org.tensorflow.OperationBuilder;
import org.tensorflow.Output;
import org.tensorflow.op.PrimitiveOp;
import org.tensorflow.op.Scope;

/**
 * Checks whether a tree ensemble has been initialized.
 */
@Generated(value = "TensorFlow Java Op Generator")
public final class IsBoostedTreesEnsembleInitialized extends PrimitiveOp implements Operand<Boolean> {
  
  /**
   * Factory method to create a class to wrap a new IsBoostedTreesEnsembleInitialized operation to the graph.
   * 
   * @param scope current graph scope
   * @param treeEnsembleHandle Handle to the tree ensemble resouce.
   * @return a new instance of IsBoostedTreesEnsembleInitialized
   */
  public static IsBoostedTreesEnsembleInitialized create(Scope scope, Operand<?> treeEnsembleHandle) {
    OperationBuilder opBuilder = scope.graph().opBuilder("IsBoostedTreesEnsembleInitialized", scope.makeOpName("IsBoostedTreesEnsembleInitialized"));
    opBuilder.addInput(treeEnsembleHandle.asOutput());
    return new IsBoostedTreesEnsembleInitialized(opBuilder.build());
  }
  
  /**
   * output boolean on whether it is initialized or not.
   */
  public Output<Boolean> isInitialized() {
    return isInitialized;
  }
  
  @Override
  public Output<Boolean> asOutput() {
    return isInitialized;
  }
  
  private Output<Boolean> isInitialized;
  
  private IsBoostedTreesEnsembleInitialized(Operation operation) {
    super(operation);
    int outputIdx = 0;
    isInitialized = operation.output(outputIdx++);
  }
}
