/* Copyright 2018 The TensorFlow Authors. All Rights Reserved.

Licensed under the Apache License, Version 2.0 (the "License");
you may not use this file except in compliance with the License.
You may obtain a copy of the License at

    http://www.apache.org/licenses/LICENSE-2.0

Unless required by applicable law or agreed to in writing, software
distributed under the License is distributed on an "AS IS" BASIS,
WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
See the License for the specific language governing permissions and
limitations under the License.
=======================================================================*/

package org.tensorflow.op.core;

import javax.annotation.Generated;
import org.tensorflow.Operand;
import org.tensorflow.Operation;
import org.tensorflow.OperationBuilder;
import org.tensorflow.Output;
import org.tensorflow.op.PrimitiveOp;
import org.tensorflow.op.Scope;
import org.tensorflow.op.annotation.Operator;

/**
 * Strip leading and trailing whitespaces from the Tensor.
 */
@Generated(value = "TensorFlow Java Op Generator")
@Operator(group = "core")
public final class StringStrip extends PrimitiveOp implements Operand<String> {
  
  /**
   * Factory method to create a class to wrap a new StringStrip operation to the graph.
   * 
   * @param scope current graph scope
   * @param input A string {@code Tensor} of any shape.
   * @return a new instance of StringStrip
   */
  public static StringStrip create(Scope scope, Operand<String> input) {
    OperationBuilder opBuilder = scope.graph().opBuilder("StringStrip", scope.makeOpName("StringStrip"));
    opBuilder.addInput(input.asOutput());
    return new StringStrip(opBuilder.build());
  }
  
  /**
   * A string {@code Tensor} of the same shape as the input.
   */
  public Output<String> output() {
    return output;
  }
  
  @Override
  public Output<String> asOutput() {
    return output;
  }
  
  private Output<String> output;
  
  private StringStrip(Operation operation) {
    super(operation);
    int outputIdx = 0;
    output = operation.output(outputIdx++);
  }
}
