/* Copyright 2018 The TensorFlow Authors. All Rights Reserved.

Licensed under the Apache License, Version 2.0 (the "License");
you may not use this file except in compliance with the License.
You may obtain a copy of the License at

    http://www.apache.org/licenses/LICENSE-2.0

Unless required by applicable law or agreed to in writing, software
distributed under the License is distributed on an "AS IS" BASIS,
WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
See the License for the specific language governing permissions and
limitations under the License.
=======================================================================*/

package org.tensorflow.op.core;

import javax.annotation.Generated;
import org.tensorflow.Operand;
import org.tensorflow.Operation;
import org.tensorflow.OperationBuilder;
import org.tensorflow.Output;
import org.tensorflow.op.PrimitiveOp;
import org.tensorflow.op.Scope;
import org.tensorflow.op.annotation.Operator;

/**
 * Returns the number of tensors in the input tensor list.
 * <p>
 * input_handle: the input list
 * length: the number of tensors in the list
 */
@Generated(value = "TensorFlow Java Op Generator")
@Operator(group = "core")
public final class TensorListLength extends PrimitiveOp implements Operand<Integer> {
  
  /**
   * Factory method to create a class to wrap a new TensorListLength operation to the graph.
   * 
   * @param scope current graph scope
   * @param inputHandle 
   * @return a new instance of TensorListLength
   */
  public static TensorListLength create(Scope scope, Operand<?> inputHandle) {
    OperationBuilder opBuilder = scope.graph().opBuilder("TensorListLength", scope.makeOpName("TensorListLength"));
    opBuilder.addInput(inputHandle.asOutput());
    return new TensorListLength(opBuilder.build());
  }
  
  /**
   */
  public Output<Integer> length() {
    return length;
  }
  
  @Override
  public Output<Integer> asOutput() {
    return length;
  }
  
  private Output<Integer> length;
  
  private TensorListLength(Operation operation) {
    super(operation);
    int outputIdx = 0;
    length = operation.output(outputIdx++);
  }
}
